datablock ParticleData(burstmachinegunFireParticle)
{
    dragCoefficient      = 0;
    gravityCoefficient   = 0;
    inheritedVelFactor   = 0;
    constantAcceleration = 0.0;
    lifetimeMS           = 50;
    lifetimeVarianceMS   = 0;
    textureName          = "base/data/particles/star1";
    spinSpeed        = 9000.0;
    spinRandomMin        = -5000.0;
    spinRandomMax        = 5000.0;

    colors[0]     = "1.0 0.5 0 0.9";
    colors[1]     = "0.9 0.4 0 0.8";
    colors[2]     = "1 0.5 0.2 0.6";
    colors[3]     = "1 0.5 0.2 0.4";

    sizes[0]      = 1.75;
   sizes[1]      = 0.4;
    sizes[2]      = 0.10;
    sizes[3]      = 0.0;

   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 0.5;
   times[3] = 1.0;

    useInvAlpha = false;
};
datablock ParticleEmitterData(burstmachinegunFireEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 64.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;

   particles = "burstmachinegunFireParticle";
};

datablock ParticleData(burstmachinegunTrailParticle)
{
dragCoefficient= 3.0;
windCoefficient= 0.0;
gravityCoefficient= 0.0;
inheritedVelFactor= 0.0;
constantAcceleration= 0.0;
lifetimeMS= 80;
lifetimeVarianceMS= 0;
spinSpeed= 10.0;
spinRandomMin= -50.0;
spinRandomMax= 50.0;
useInvAlpha= false;
animateTexture= false;
//framesPerSec= 1;

textureName= "base/data/particles/cloud";
//animTexName= "~/data/particles/dot";

// Interpolation variables
colors[0]= "1 1 0 0.1";
colors[1]= "1 1 0.4 0.08";
colors[2]= "0.7 0.7 0.7 0";
sizes[0]= 0.3;
sizes[1]= 0.15;
sizes[2]= 0.0;
times[0]= 0.0;
times[1]= 0.1;
times[2]= 1.0;
};
datablock ParticleEmitterData(burstmachinegunTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;
   ejectionOffset = 0;
   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = burstmachinegunTrailParticle;
};

AddDamageType("burstrifle",   '<bitmap:add-ons/Weapon_burst_rifle/CI_burstrifle> %1',    '%2 <bitmap:add-ons/Weapon_burst_rifle/CI_burstrifle> %1',0.2,1);
datablock ProjectileData(burstrifleProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 9;
   directDamageType    = $DamageType::burstrifle;
   radiusDamageType    = $DamageType::burstrifle;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse     = 0;
   verticalImpulse  = 0;
   explosion           = gunExplosion;
   particleEmitter     = burstmachinegunTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "";
};

//////////
// item //
//////////
datablock ItemData(burstrifleItem)
{
category = "Weapon";  // Mission editor category
className = "Weapon"; // For inventory system

 // Basic Item Properties
shapeFile = "./m4.dts";
rotate = false;
mass = 1;
density = 0.2;
elasticity = 0.2;
friction = 0.6;
emap = true;

//gui stuff
uiName = "Burst Rifle";
iconName = "./icon_burstrifle";
doColorShift = true;
colorShiftColor = "0.45 0.45 0.45 1.000";

 // Dynamic properties defined by the scripts
image = burstrifleImage;
canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(burstrifleImage)
{
   // Basic Item properties
   shapeFile = "./m4.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = burstrifleItem;
   ammo = " ";
   projectile = burstrifleProjectile;
   projectileType = Projectile;

casing = gunShellDebris;
shellExitDir        = "2.0 -1.3 1.0";
shellExitOffset     = "0 0 0";
shellExitVariance   = 15.0;
shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = burstrifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
// Initial start up state
stateName[0]                     = "Activate";
stateTimeoutValue[0]             = 0.1;
stateTransitionOnTimeout[0]       = "Ready";

stateSound[0]= activateSound;

stateName[1]                     = "Ready";
stateTransitionOnTriggerDown[1]  = "Fire";
stateAllowImageChange[1]         = true;

stateSequence[1]= "Ready";

stateName[2]                    = "Fire";
stateTransitionOnTimeout[2]     = "Fire2";
stateTimeoutValue[2]            = 0.055;
stateFire[2]                    = true;
stateAllowImageChange[2]        = false;
stateSequence[2]                = "fire";
stateScript[2]                  = "onFire";
stateWaitForTimeout[2]= true;
stateEmitter[2]= burstmachinegunFireEmitter;
stateEmitterTime[2]= 0.04;
stateEjectShell[2]         = true;
stateEmitterNode[2]= "muzzleNode";
stateSound[2]= gunshot1Sound;
   stateSequence[2]                = "Fire";
stateEjectShell[2]       = true;

stateName[3]                    = "Fire2";
stateTransitionOnTimeout[3]     = "Fire3";
stateTimeoutValue[3]            = 0.055;
stateFire[3]                    = true;
stateAllowImageChange[3]        = false;
stateSequence[3]                = "fire";
stateScript[3]                  = "onFire";
stateWaitForTimeout[3]= true;
stateEmitter[3]= burstmachinegunFireEmitter;
stateEmitterTime[3]= 0.04;
stateEjectShell[3]         = true;
stateEmitterNode[3]= "muzzleNode";
stateSound[3]= gunshot1Sound;
   stateSequence[3]                = "Fire";
stateEjectShell[3]       = true;

stateName[4]                    = "Fire3";
stateTransitionOnTimeout[4]     = "Smoke";
stateTimeoutValue[4]            = 0.055;
stateFire[4]                    = true;
stateAllowImageChange[4]        = false;
stateSequence[4]                = "fire";
stateScript[4]                  = "onFire";
stateWaitForTimeout[4]= true;
stateEmitter[4]= burstmachinegunFireEmitter;
stateEmitterTime[4]= 0.04;
stateEjectShell[4]         = true;
stateEmitterNode[4]= "muzzleNode";
stateSound[4]= gunshot1Sound;
   stateSequence[4]                = "Fire";
stateEjectShell[4]       = true;

stateName[5] = "Smoke";
stateTimeoutValue[5]            = 0.25;
stateTransitionOnTimeout[5]     = "Ready";
stateEmitter[5]= gunSmokeEmitter;
stateEmitterTime[5]= 0.225;
stateEmitterNode[5]= "muzzleNode";
};

function burstrifleImage::onFire(%this,%obj,%slot)
{
if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
return;
%obj.lastFireTime = getSimTime();

%obj.playThread(2, plant);

%projectile = %this.projectile;
%spread = 0.001;
%shellcount = 1;

for(%shell=0; %shell<%shellcount; %shell++)
{
%vector = %obj.getMuzzleVector(%slot);
%objectVelocity = %obj.getVelocity();
%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
%velocity = VectorAdd(%vector1,%vector2);
%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
%velocity = MatrixMulVector(%mat, %velocity);

%p = new (%this.projectileType)()
{
dataBlock = %projectile;
initialVelocity = %velocity;
initialPosition = %obj.getMuzzlePoint(%slot);
sourceObject = %obj;
sourceSlot = %slot;
client = %obj.client;
};
MissionCleanup.add(%p);
}
return %p;
}
